package com.unitesk.requality.core;

import java.util.Set;

public abstract class TreeChangeListener implements ITreeChangeListener {


    @Override
    public void changed(TreeNode node, Set<String> what, boolean internal) {
        changed(node, what);
    }
	
    @Override
    public void created(TreeNode node, boolean internal) {
        created(node);
    }

    @Override
    public void deleted(NodeDesc node, boolean internal) {
        deleted(node);
    }

    @Override
    public void moved(TreeNode node, TreeNode oldParent, boolean internal) {
        moved(node, oldParent);
    }

    public abstract void changed(TreeNode node, Set<String> what);

    public abstract void created(TreeNode node);

    public abstract void deleted(NodeDesc node);

    public abstract void moved(TreeNode node, TreeNode oldParent);

}
