package com.unitesk.requality.core.attribute;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ListValue implements Iterable<Object>, Cloneable{
	private AttributeType type;
	private List<Object> values;
	public ListValue(AttributeType atype, List<Object> values){
		this.type = atype;
		this.values = values;
	}
	public AttributeType getType(){
		return type;
	}
	public List<Object> getValues(){
		return values;
	}
	@Override
	public Iterator<Object> iterator() {
		return new Iterator<Object>() {
			int ind = 0;
			@Override
			public void remove() {
				values.remove(ind);
			}
			
			@Override
			public Object next() {
				return values.get(ind++);
			}
			
			@Override
			public boolean hasNext() {
				return ind<values.size();
			}
		};
	}
	@Override
	protected Object clone() throws CloneNotSupportedException {
		List<Object> lst = new ArrayList<Object>();
		for(Object o:values)
		{
			if(type == AttributeType.ENUM)
				lst.add(((AppliedEnumValue)o).clone());
			else if(type == AttributeType.LIST)
				lst.add(((ListValue)o).clone());
			else if(type == AttributeType.ENUM_DEFINITION)
				lst.add(((EnumDefinitionValue)o).clone());
			else lst.add(o);
		}
		return new ListValue(type, values);
	}
}
