package com.unitesk.requality.core.checkers;

import com.unitesk.requality.core.TreeNode;

/**
 * 
 * Class represents problems over Tree Nodes
 *
 */
public class CheckerProblem {
    private TreeNode target;
    private String description;
    
    public CheckerProblem(TreeNode target, String description) {
        this.target = target;
        this.description = description;
    }
    /**
     * Get description of problem 
     * @return text of problems description
     */
    public String getDescription() {
        return description;
    }

    /**
     * Get node where problem appears
     * @return tree node
     */
    public Object getTarget() {
        return target;
    }

    @Override
    public String toString() {
        return target.toString()+": "+description;
    }
}
