package com.unitesk.requality.core.domproxy;


import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;
import org.dom4j.InvalidXPathException;

import com.unitesk.requality.core.TreeNode;

public class LinkResolver {
	public LinkResolver(){
	}
	Document proxy = null;
	public TreeNode resolveSingle(TreeNode targ, String path){
		TreeNode[]res = resolve(targ, path);
		if(res!=null && res.length>0)
			return res[0];
		return null;
	}
	public TreeNode[] resolve(TreeNode targ, String path){
		try{
			TreeNode sres = targ.getTreeDB().getNode(path);
			if(sres!=null)
				return new TreeNode[]{sres};
		}
		catch(Exception e){}
		if(proxy == null)
			proxy = DocumentHelper.createDocument(RequalityElement.toElement(targ.getTreeDB().getRootNode()));
		RequalityElement.toElement(targ.getTreeDB().getRootNode()).setDocument(proxy);
		RequalityElement rer = RequalityElement.toElement(targ);
		org.dom4j.XPath xpath;
		try{
			xpath=proxy.createXPath(path);
		}catch(InvalidXPathException icpe){
			return null;
		}
		try{
			Object result=xpath.evaluate(rer);
	 		if(result instanceof Collection<?>){
				List<TreeNode> res= new ArrayList<TreeNode>();
				for(Element re:(Collection<Element>)result)
					res.add(((RequalityElement) re).getWrappedTreeNode());
				if(res.size()==0)
					return null;
				return res.toArray(new TreeNode[0]);
			}
			if(result instanceof RequalityElement){
				return new TreeNode[]{((RequalityElement)result).getWrappedTreeNode()};
			}
		}
		catch(Exception e){
			e.printStackTrace();
		}
		return null;
	}
	public boolean verify(TreeNode targ, String path) {
		try{
			TreeNode sres = targ.getTreeDB().getNode(path);
			if(sres!=null)
				return sres.equals(targ);
		}
		catch(Exception e){}
		if(proxy == null)
			proxy = DocumentHelper.createDocument(RequalityElement.toElement(targ.getTreeDB().getRootNode()));
		RequalityElement.toElement(targ.getTreeDB().getRootNode()).setDocument(proxy);
		RequalityElement rer = RequalityElement.toElement(targ);
		org.dom4j.XPath xpath;
		try{
			xpath=proxy.createXPath(path);
		}catch(InvalidXPathException icpe){
			return false;
		}
		return xpath.matches(RequalityElement.toElement(targ));
	}
}
