package com.unitesk.requality.core.transaction;

import java.util.Collection;
import java.util.Set;
import java.util.TreeSet;
import java.util.UUID;

import com.unitesk.requality.core.ITreeStorage;
import com.unitesk.requality.core.attribute.Attribute;

public class SaveAttributes extends TreeOperation {
    private UUID uuid;
    private Collection<Attribute> oldAttributes;
    private Collection<Attribute> newAttributes;
    private Set<String> changed;

    public SaveAttributes(UUID uuid, Collection<Attribute> oldAttributes, Collection<Attribute> newAttributes, Set<String> altered) {
        this.uuid = uuid;
        //deeply copy attributes
        this.oldAttributes = new TreeSet<Attribute>();
        for (Attribute oldAttr : oldAttributes) 
            this.oldAttributes.add(Attribute.deepCopy(oldAttr));
        this.newAttributes = new TreeSet<Attribute>();
        for (Attribute newAttr : newAttributes)
            this.newAttributes.add(Attribute.deepCopy(newAttr));
        this.changed = altered;
    }
    
    @Override
    public void apply(ITreeStorage storage) {
        storage.saveAttributes(uuid, changed, newAttributes);
    }

    @Override
    public void rollback(ITreeStorage storage) {
        storage.saveAttributes(uuid, changed, oldAttributes);
    }

}
