package com.unitesk.requality.eclipse.handlers;

import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchWindow;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.eclipse.ui.RequalityLCNF;
import com.unitesk.requality.eclipse.ui.dialogs.ReferenceNameSelectionDialog;
import com.unitesk.requality.eclipse.views.RequalityContentLinksProvider;
import com.unitesk.requality.nodetypes.Requirement;

public class SelectLinksAttribute extends AbstractHandler {
    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
    	org.eclipse.swt.widgets.Event e = (org.eclipse.swt.widgets.Event)(event.getTrigger());
    	//ToolItem ti = ((ToolItem)e.widget);
    	Map<String,List<TreeNode>> act=Activator.getDefault().getActiveNodes();
    	for(List<TreeNode> tn:act.values())
    		if(tn.size()>0){
	    		Map<TreeDB, String[]> back = ReferenceNameSelectionDialog.getSavedState();
	    		ReferenceNameSelectionDialog asp = new ReferenceNameSelectionDialog(tn.get(0).getTreeDB(),getShell());
	    		if(asp.open()==org.eclipse.jface.dialogs.Dialog.CANCEL)
	    			ReferenceNameSelectionDialog.restoreSavedState(back);
	    		else{
	    			String[] res = ReferenceNameSelectionDialog.getSavedState().get(tn.get(0).getTreeDB());
	    			RequalityLCNF.setFilter(tn.get(0).getTreeDB(),
	    					res==null?null:new HashSet<String>(Arrays.asList(res)));
	    		}
	    		return true;
	    	}
		return true;
    }
    @Override
    public boolean isEnabled() {
    	return true;
    }
    private static Shell getShell(){
    	if(Activator.getDefault() == null)
    		return null;
    	IWorkbench w = Activator.getDefault().getWorkbench();
    	if(w==null)
    		return null;
    	IWorkbenchWindow win = w.getActiveWorkbenchWindow();
    	if(win == null)
    		return null;
    	return win.getShell();
    }
}
