package com.unitesk.requality.eclipse.handlers.location;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.ui.commands.IElementUpdater;
import org.eclipse.ui.menus.UIElement;

import com.unitesk.requality.core.IDeleteHandler;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.nodetypes.Location;

public class RemoveLocationHandler extends AbstractHandler implements IDeleteHandler,IElementUpdater{

    public void recUpdateProcessed(TreeNode node, List<UUID> toprocess){
        toprocess.add(node.getUUId());
        for(UUID uid :node.getChildrenUUIds()){
            TreeNode nde = node.getTreeDB().getNode(uid);
            recUpdateProcessed(nde, toprocess);
        }
    }
    @SuppressWarnings("rawtypes")
    @Override
    public void updateElement(UIElement element, Map parameters) {
    	List<TreeNode> sel = RequalityCNF.getSelectedNodes();
    	int cnt = 0;
    	for(TreeNode node : sel)
    		if(node.getType().equals(Location.TYPE_NAME))
    			cnt++;
    	element.setText("Delete Location"+((cnt>1)?"s":""));
    }
    boolean batch = true;
    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException{
        List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
        if(nodes == null)
            return false;
        batch = false;
        process(nodes, new ArrayList<UUID>(), nodes.size()>1);
        return null;
    }

    @Override
    public boolean isEnabled() {
        List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
        if (nodes == null) {
            return false;
        }
        for(TreeNode node : nodes)
            if (!node.getType().equals(Location.TYPE_NAME))
                return false;
        return true;
    }

    @Override
    public boolean isSuitableFor(TreeNode tn) {
        return tn.getType().equals(Location.TYPE_NAME);
    }

    @Override
    public void process(List<TreeNode> nodes, List<UUID> processed, boolean multi)
            throws ExecutionException {
        for(TreeNode node : nodes){
            if(!isSuitableFor(node))
                continue;
            if(processed.contains(node.getUUId()))
                continue;
            Location loc = (Location) node;

            List<UUID>toprocess = new ArrayList<UUID>();
            recUpdateProcessed(node, toprocess);
            CommonRemoveLocation.RemoveLocation(loc, null, null, batch);
            processed.addAll(toprocess);
        }
    }

	@Override
	public String[] getWarnings(List<TreeNode> nodes) {
		return null;
	}

	@Override
	public String titleOverride(List<TreeNode> nodes) {
		return null;
	}

}
