/*
 * Copyright 2015 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.unitesk.requality.eclipse.handlers.report;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.core.attribute.AttributeType;
import com.unitesk.requality.eclipse.handlers.NewElementHandler;
import com.unitesk.requality.nodetypes.ReportSettings;
import com.unitesk.requality.report.Template;

public class CreateReportSettingsHandler extends NewElementHandler {
	
	@Override
	public String[] getElementTypes() {
		return new String[]{ReportSettings.TYPE_NAME};
	}

	@Override
	protected void setElementSpecificAttributes(TreeNode nn) {
		nn.putAttribute(new Attribute(nn, AttributeType.STRING, ReportSettings.ATTR_TEMPLATE, Template.DEFAULT_ID));
	}
}
