/*
 * Copyright 2015 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.requality.eclipse.views.properties;

import org.eclipse.core.resources.IProject;
import org.eclipse.jface.viewers.StructuredSelection;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.core.TreesTracker;


public class ProjectSettingsTemplatesSection extends TreeNodePropertiesTab{

	TemplatesPanel panel;

	@Override
	public void createControls(org.eclipse.swt.widgets.Composite parent, org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage aTabbedPropertySheetPage) {
		panel = new TemplatesPanel(parent);
	};
    @Override
    public void setInput(org.eclipse.ui.IWorkbenchPart part, org.eclipse.jface.viewers.ISelection selection) {
    	if(selection!=null){
    		IProject p = (IProject) ((StructuredSelection)selection).getFirstElement();
    		if(p!=null)
    			panel.setTreeDB(TreesTracker.getTracker().getTree(p));
    	}
    }
	@Override
	protected void setTreeNode(TreeNode node) {
		// TODO Auto-generated method stub
		
	}
}
