package com.unitesk.requality.marker;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.viewers.IDecoration;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ILightweightLabelDecorator;

import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.attribute.Attribute;
import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.nodetypes.Requirement;

public class TransferredRequirementDecorator implements ILightweightLabelDecorator{

	public TransferredRequirementDecorator() {
		super();
	}
	@Override
    public void addListener(ILabelProviderListener listener) {
    }

    @Override
    public void dispose() {
    }

    @Override
    public void decorate(Object element, IDecoration decoration) {
    	try{
//    		System.out.println("in decorator");
    		TreeNode node = (TreeNode) element;
    		// TODO
    		Attribute attr = node.getAttribute(Requirement.ATTR_TRANSF_STATUS);
//    		Requirement.TransferStatus status = Requirement.TransferStatus.
//    				valueOf(node.getAttribute(Requirement.ATTR_TRANSF_STATUS)
    		if(attr != null){
//    			System.out.println("in decorator, attr is not null");
    			ImageDescriptor id;
//    			Requirement.TransferStatus status = Requirement.TransferStatus.valueOf(attr.toString());
    			Requirement.TransferStatus status = Requirement.TransferStatus.valueOf(attr.getRawValue().toString());
    			if (status.equals(Requirement.TransferStatus.COMPLETE)) {
    				id = Activator.getImageDescriptor(
        	                "icons/overlays/rq_transferred_complete.png");	
    			} else	if (status.equals(Requirement.TransferStatus.INCOMPLETE)) {
    				id = Activator.getImageDescriptor(
        	                "icons/overlays/rq_transferred_incomplete.png");
    			} else {
    				 id = Activator.getImageDescriptor(
    	    	                "icons/overlays/rq_transferred_failed.png");
    			}
    			
//    			System.out.println("id = " + id);
    			
    	        decoration.addOverlay(id, IDecoration.TOP_RIGHT);
    		}
    	}catch(Exception e){
    		e.printStackTrace();
    	}
    }

    @Override
    public void removeListener(ILabelProviderListener listener) {
    }

    @Override
    public boolean isLabelProperty(Object element, String property) {
        return true;
    }
}